{{
********************************
* jvmMain - top object for JVM *
********************************
}}


CON

  'clock settings for spin stamp
  _clkmode = xtal1+pll8x
  _xinfreq = 10_000_000
  'clock settings for propeller board
'  _clkmode = xtal1+pll16x
'  _xinfreq = 5_000_000
  
  commPort = 1 '0=none, 1=propeller TX/RX, 2=spin stamp SOUT/SIN/ATN

  
OBJ
  jvm:   "jvmEngine"    'the bytecode interpreter
  comm:  "jvmComm"      'communication port object
  jd:    "jvmData"      'jvm memory access object
  nf:    "jvmNative"    'native functions
  jprog: "jvmJavaProg"  'storage area for java bytecodes (MUST ONLY BE INCLUDED HERE)
  
  
PUB main | c
{{ application starts here }}
  comm.start(commPort,true)
  'waitcnt(clkfreq*5 + cnt) 'wait 5 second
  comm.setReset
  repeat 'keep running
    jd.init(jprog.getJavaProgram,jprog#JAVASIZE,commPort)  'initialize jvm registers and pass javaProg properties
    if comm.isReset
      comm.doReset
      comm.clearReset
      repeat
        c := comm.doDebug
      until c == -1
    else
      'mainloop
      repeat while NOT comm.isReset
        if jd.debugger
          c := comm.doDebug 'check for debug commands
        c := jvm.doBytecode 'execute next bytecode
        case c
          0..47: nf.doNative(c)
          'add userdefined native functions here
          
      